package chain_transfer

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/chain_transfer/svc"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/haodanku"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/taobao"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/tik_tok"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"fmt"
	"github.com/tidwall/gjson"
	"strings"
	"xorm.io/xorm"
)

/***
master_id  站长id
provider  渠道
gid 商品id
uid 用户id
*/
func ChainTransfer(eg *xorm.Engine, args map[string]string) map[string]string {
	var res = make(map[string]string)
	res["url"] = ""
	res["word"] = ""
	userProfile, _ := db.UserProfileFindByID(eg, args["uid"])

	UnionId := ""
	if userProfile != nil {
		if args["provider"] == md.PVD_TB || args["provider"] == md.PVD_TM {
			//新的渠道id 存储
			relation := db.GetTaobaoUserRelationByUid(eg, userProfile.Uid)
			if relation != nil {
				userProfile.AccTaobaoShareId = relation.RelationId
				UnionId = zhios_third_party_utils.IntToStr(relation.UnionId)
			}
		}
		args["acc_taobao_share_id"] = zhios_third_party_utils.Int64ToStr(userProfile.AccTaobaoShareId)
		if userProfile.AccJdCloudId == "" {
			userProfile.AccJdCloudId = userProfile.AccJdShareId
		}
		args["acc_jd_share_id"] = userProfile.AccJdCloudId
		args["acc_pdd_self_id"] = userProfile.AccPddSelfId
	}
	switch args["provider"] {
	case md.PVD_TB, md.PVD_TM:
		taobaoSdk, err := taobao.NewTaobaoSDK(eg, args["master_id"], args["platform"], zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]), UnionId)
		if err != nil {
			return res
		}
		bizSceneId := "2"
		tbItemInfo, err := taobaoSdk.ItemDetailById(args["gid"], bizSceneId)
		if err != nil {
			fmt.Println("=======商品1", err)

			return res
		}
		if tbItemInfo != nil {
			args["gid"] = zhios_third_party_utils.AnyToString(tbItemInfo.ItemID)
		}
		curls, err := svc.ConvertUrl(eg, args)
		if err != nil || curls == nil {
			return res
		}
		//调用好单库
		itemInfo, _ := haodanku.HaodankuDetail(args["gid"])
		//如果优惠券高
		if zhios_third_party_utils.StrToFloat64(itemInfo.CouponAmount) > zhios_third_party_utils.StrToFloat64(tbItemInfo.CouponAmount) && zhios_third_party_utils.StrToFloat64(itemInfo.CouponAmount) > 0 {
			curls.ShortenURL = "https://uland.taobao.com/coupon/edetail?activityId=" + itemInfo.ActivityId + "&itemId=" + args["gid"] + "&pid=" + taobaoSdk.SharePromoIdWeb + "&nowake=1"
		}
		//如果是小程序 并且没有渠道id 就用会员运营id 和推广位
		if zhios_third_party_utils.StrToInt(args["acc_taobao_share_id"]) == 0 {
			if curls.NewPid != "" {
				curls.ShortenURL = curls.ShortenURL + "&relationId=" + zhios_third_party_utils.Int64ToStr(curls.TbShareId)
			}
		} else {
			curls.ShortenURL = curls.ShortenURL + "&relationId=" + args["acc_taobao_share_id"]
		}

		if curls.TaoBaoWord == "" {
			// 生成淘口令
			taokou, err := taobaoSdk.WordCreate(curls.ShortenURL, "12345")
			if err != nil {
				taokou = new(md.TaobaoWord)
			}
			curls.TaoBaoWord = taokou.Text
		}
		res["url"] = curls.ShortenURL
		res["word"] = curls.TaoBaoWord
	case md.PVD_JDS:

	case md.PVD_TIKTOK, md.PVD_KUAISHOU:
		// 分享
		if args["provider"] == md.PVD_TIKTOK {
			args["coupon_url"] = "https://haohuo.jinritemai.com/views/product/item2?id=" + args["gid"]
			if strings.Contains(args["gid"], "cid") {
				ex := strings.Split(args["gid"], "cid")
				if len(ex) == 2 {
					args["gid"] = ex[0]
					args["activityId"] = ex[1]
				}
				newTeamToken := ""
				selectionLibraryTeamKey, _ := db.SysCfgGetOne(eg, "selection_library_team_key")
				if selectionLibraryTeamKey != nil {
					newTeamToken = gjson.Get(selectionLibraryTeamKey.Val, "teamAccessToken").String()
				}
				appkey := ""
				secretKey := ""
				thirdZmAppKeyData, _ := db.SysCfgGetOne(eg, "third_zm_app_key")
				if thirdZmAppKeyData != nil {
					appkey = thirdZmAppKeyData.Val
				}
				thirdZmAppSecretData, _ := db.SysCfgGetOne(eg, "third_zm_app_secret")
				if thirdZmAppSecretData != nil {
					secretKey = thirdZmAppKeyData.Val
				}
				tikTokBase, _ := tik_tok.Base(eg, args["master_id"], "")
				detailUrl := ""
				if args["activityId"] != "" {
					postData := map[string]interface{}{}
					postData["gid"] = args["gid"]
					postData["appkey"] = appkey
					postData["secret_key"] = secretKey
					postData["category_id"] = args["activityId"]
					postData["p"] = "1"
					postData["size"] = "1"
					postData["token"] = newTeamToken
					list, _ := tik_tok.OwnTeamGoods(tikTokBase, postData)
					fmt.Println(list)
					if list != nil {
						for _, v := range *list {
							if v.GoodsID == args["gid"] {
								detailUrl = v.DetailURL
							}
						}
					}
				}
				if detailUrl != "" {
					postData := map[string]interface{}{
						"product_url":  detailUrl,
						"pick_extra":   args["master_id"] + "_" + args["uid"],
						"newTeamToken": newTeamToken,
					}
					fmt.Println(postData)
					detailUrlData, err := tik_tok.OwnTeamUrl(tikTokBase, postData)
					fmt.Println(detailUrlData)
					if err == nil && detailUrlData["product_url"] != "" {
						args["coupon_url"] = detailUrlData["product_url"]
					}
				}

			}
		}

	case md.PVD_VIP:

	}
	if zhios_third_party_utils.InArr(args["provider"], []string{md.PVD_TB, md.PVD_TM}) == false {
		curls, err := svc.ConvertUrl(eg, args)
		if err != nil || curls == nil {
			return res
		}
		res["url"] = curls.ShortenURL
		if args["provider"] == md.PVD_KUAISHOU {
			res["url"] = curls.NoOpenAppURL
		}
		if args["provider"] == md.PVD_TIKTOK {
			res["url"] = curls.H5Url
			if curls.Content != "" {
				res["word"] = curls.Content
			}
		}

	}
	return res
}
