package chain_transfer

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/chain_transfer/svc"
	taoke "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/dataoke"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/md"
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"fmt"
	"github.com/mvdan/xurls"
	"regexp"
	"strings"
	"time"
	"xorm.io/xorm"
)

func TurnChain(eg *xorm.Engine, officialEg *xorm.Engine, args map[string]string) md.TCPrase {
	dbName := args["master_id"]
	var tcPrase md.TCPrase
	tcPrase.TurnGoods = make([]md.TurnGoods, 0)
	db.UserFindByID(eg, args["uid"])
	now := time.Now()
	PlatType := ""
	args["platType"] = PlatType
	user, _ := db.UserFindByID(eg, args["uid"])
	userProfile, _ := db.UserProfileFindByID(eg, user.Uid)
	if userProfile != nil {
		//新的渠道id 存储
		relation := db.GetTaobaoUserRelationByUid(eg, userProfile.Uid)
		if relation != nil {
			userProfile.AccTaobaoShareId = relation.RelationId
			args["union_id"] = zhios_third_party_utils.IntToStr(relation.UnionId)
		}
		args["acc_taobao_share_id"] = zhios_third_party_utils.Int64ToStr(userProfile.AccTaobaoShareId)
		if userProfile.AccJdCloudId == "" {
			userProfile.AccJdCloudId = userProfile.AccJdShareId
		}
		args["acc_jd_share_id"] = userProfile.AccJdCloudId
		args["acc_pdd_self_id"] = userProfile.AccPddSelfId
	}
	//1、识别出对应平台的口令或链接
	reqCount := args["content"]
	if reqCount == "" {
		return tcPrase
	}
	reqCount = strings.ReplaceAll(reqCount, "\n￥", "￥")
	reqCount = strings.ReplaceAll(reqCount, "http", "\nhttp")
	reqCounts := reqCount
	if strings.Contains(reqCount, "￥") {
		reqCounts = ""
		splits := strings.Split(reqCount, "￥")
		for k, v := range splits {
			if k == 0 {
				reqCounts += v + "\n￥"
			} else if k+1 == len(splits) {
				reqCounts += v
			} else {
				reqCounts += v + "￥"
			}
		}
	}
	reqCount = reqCounts
	findAllUrl := xurls.Strict.FindAllString(reqCount, -1)
	var pvd, goodsId, tklWord string
	reg1 := regexp.MustCompile(`￥.*?￥`)
	matched := reg1.FindAllStringSubmatch(reqCount, -1)
	isTikTok := "0"
	if strings.Contains(reqCount, "dou音") || strings.Contains(reqCount, "buydouke") || (strings.Contains(reqCount, "抖音") || strings.Contains(reqCount, "douyin")) && strings.Contains(reqCount, "【") {
		isTikTok = "1"
	}
	split := strings.Split(reqCount, "\n")
	reqCount = strings.ReplaceAll(reqCount, "\nhttp", "http")
	if isTikTok == "1" {
		pvd, goodsId, tklWord, _ := svc.FindTaobaoWord(eg, officialEg, args, reqCount, user)
		if goodsId != "" || tklWord != "" {
			tcPrase, _ = svc.CommGetGoods(eg, officialEg, args, tcPrase, 1, reqCount, pvd, goodsId, reqCount, tklWord, "0")
		}
	} else if len(split) > 0 {
		for _, v := range split {
			if strings.Contains(v, "m.tb") || strings.Contains(reqCount, "taobao.com") || strings.Contains(reqCount, "tmall.com") {
				PlatType = "has"
			}
			if strings.Contains(v, "haohuo.jinritemai.") {
				PlatType = "has"

			}
			if strings.Contains(v, "jd.") {
				PlatType = "has"

			}
			if strings.Contains(v, "pinduoduo.com") || strings.Contains(v, "yangkeduo.com") {
				PlatType = "has"

			}
			if strings.Contains(v, "kaola.com") {
				PlatType = "has"

			}
			if strings.Contains(v, "suning.") {
				PlatType = "has"

			}
			if strings.Contains(v, "vip.") {
				PlatType = "has"

			}
		}
		if PlatType == "" {
			parse, _ := taoke.DaTaoKeContentParse(args["content"])
			//fmt.Println("============1", time.Since(now))
			args["platType"] = parse.PlatType
			if parse.DataType == "activity" {

			}
		}
		for k, v := range split {
			if v == "" {
				continue
			}
			isFirst := 1
			if k > 0 && tcPrase.GID != "" {
				isFirst = 0
			}
			if strings.Contains(v, "m.tb") || strings.Contains(reqCount, "taobao.com") || strings.Contains(reqCount, "tmall.com") {
				// 淘口令
				//fmt.Println(s)
				pvd, goodsId, tklWord, _ = svc.FindTaobaoWord(eg, officialEg, args, v, user)
				tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, pvd, goodsId, v, tklWord, "0")
			}
			if strings.Contains(v, "haohuo.jinritemai.") {
				//https://haohuo.jinritemai.com/ecommerce/trade/detail/index.html?id=3556342393857024570&ins_activity_param=yNAkhfs&origin_type=pc_buyin_group&pick_source=v.6nZos
				tikTokBase := svc.CommTik(eg, dbName, v)
				url := strings.ReplaceAll(v, "?", "&") + "&"
				split := strings.Split(url, "&id=")
				if len(split) == 2 {
					split1 := strings.Split(split[1], "&")
					if len(split1) > 0 {
						for k1, v1 := range tikTokBase {
							args[k1] = v1
						}
						tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_TIKTOK, split1[0], v, tklWord, "0")
						if zhios_third_party_utils.StrToInt(tikTokBase["tik_activity_id"]) > 0 && strings.Contains(tcPrase.GID, "cid") == false {
							tcPrase.GID += "cid" + tikTokBase["tik_activity_id"]
						}
					}
				}
			}
			if strings.Contains(v, "jd.") {
				//只有链接带有.html才会剥离出商品id
				if strings.Contains(v, ".html") {
					var index int
					s1 := v
					split := strings.Split(s1, "/")
					for i, s := range split {
						if strings.Contains(s, ".html") {
							index = i
						}
					}
					goodsidStrs := strings.Split(split[index], ".html")
					if len(goodsidStrs) > 0 {
						tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_JD, goodsidStrs[0], v, tklWord, "0")
					}
				} else {
					findAllUrl1 := xurls.Strict.FindAllString(v, -1)
					for _, v1 := range findAllUrl1 {
						tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_JD, "", v1, tklWord, "0")
					}
				}
			}
			if strings.Contains(v, "pinduoduo.com") || strings.Contains(v, "yangkeduo.com") {
				split := strings.Split(v, "?")
				if len(split) > 1 {
					sUrl := strings.Split(split[1], "&")
					if len(sUrl) > 0 {
						for _, v2 := range sUrl {
							if strings.Contains(v2, "goods_id=") {
								goods := strings.Split(v2, "=")
								tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_PDD, goods[1], v, tklWord, "0")
							}
						}

					}
				} else {
					tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_PDD, "", v, tklWord, "0")
				}
			}
			if strings.Contains(v, "kaola.com") {
				var index int
				s1 := v
				split := strings.Split(s1, "/")
				for i, s := range split {
					if strings.Contains(s, ".html") {
						index = i
					}
				}
				goodsidStrs := strings.Split(split[index], ".html")
				if len(goodsidStrs) > 0 {
					tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_KL, goodsidStrs[0], v, tklWord, "0")
				}
				return tcPrase
			}
			if strings.Contains(v, "suning.") {
				r, _ := regexp.Compile(`/(\d+)/(\d+).html`)
				reg := r.FindStringSubmatch(v)
				if len(reg) < 3 {
					return tcPrase
				}
				bytes := []byte(reg[2])
				var index int
				for i, b := range bytes {
					if b != byte(48) {
						index = i
						break
					}
				}
				i := bytes[index:len(bytes)]
				fmt.Println(string(i))
				tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_SN, string(i), v, tklWord, "0")
			}
			if strings.Contains(v, "vip.") {
				gid := ""
				if strings.Contains(v, "goodsId=") {
					split := strings.Split(v+"&", "&")
					for _, v := range split {
						if strings.Contains(v, "goodsId=") {
							gid = strings.ReplaceAll(v, "goodsId=", "")
						}
					}
				} else {
					var index int
					s1 := v
					split := strings.Split(s1, "/")
					for i, s := range split {
						if strings.Contains(s, ".html") {
							index = i
						}
					}
					goodsidStrs := strings.Split(split[index], ".html")
					if len(goodsidStrs) > 0 {
						product := strings.Split(goodsidStrs[0], "-")
						gid = product[len(product)-1]
					}
				}
				tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_VIP, gid, v, tklWord, "0")
			}
			newV := strings.ToLower(v)
			for i := 0; i < 10; i++ {
				newV = strings.ReplaceAll(newV, zhios_third_party_utils.IntToStr(i), "")
			}
			if strings.Contains(v, "￥") == false && strings.Contains(v, "http") == false {
				var numArr = []string{" ", "（", "(", "、", "-", "~", ".", "。", "！", "/", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"}
				for _, v1 := range numArr {
					newV = strings.ReplaceAll(newV, v1, "")
				}
			}
			split := regexp.MustCompile("[a-zA-Z0-9]{9,14}").FindAllString(v, -1)
			//split_letter := regexp.MustCompile("[a-zA-Z]{8,15}").FindAllString(reqCount, -1)
			if split != nil && ((zhios_third_party_utils.IsChineseChar(v) && strings.Contains(v, "http")) || strings.Contains(v, "http") == false) {
				var is_tkl = 0
				for k1, v1 := range split {
					if k1 == 0 {
						is_tkl = 1
						tklWord = v1
					}
				}
				if is_tkl == 1 {
					PlatType = "tkl"
				}
			}
			if goodsId == "" && (zhios_third_party_utils.IsAllChinese(newV) == false && (PlatType == "taobao" || PlatType == "") || PlatType == "tkl") {

				pvd, goodsId, word, _ := svc.FindTaobaoWord(eg, officialEg, args, v, user)
				if goodsId == "" && pvd == "" {
					continue
				}
				url := ""
				if zhios_third_party_utils.InArr(pvd, []string{md.PVD_TB, md.PVD_TM}) {
					url = v
					v = ""
				}
				if pvd == md.PVD_KUAISHOU {
					tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, pvd, goodsId, v, word, "1")
				} else {
					tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, pvd, goodsId, v, url, "0")
				}
			}
			fmt.Println("============"+zhios_third_party_utils.IntToStr(k+3), time.Since(now))

		}
		fmt.Println("============30", time.Since(now))

	} else if matched != nil && len(matched) > 0 {

		for k, v := range matched {
			isFirst := 1
			if k > 0 && tcPrase.GID != "" {
				isFirst = 0
			}
			for _, v1 := range v {
				pvd, goodsId, _, _ := svc.FindTaobaoWord(eg, officialEg, args, v1, user)
				url := ""
				if len(findAllUrl) > 0 {
					url = findAllUrl[k]
				}
				tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, pvd, goodsId, url, v1, "1")
			}
		}
	} else if len(findAllUrl) > 0 && isTikTok == "0" {
		for k, v := range findAllUrl {
			isFirst := 1
			if k > 0 && tcPrase.GID != "" {
				isFirst = 0
			}
			if strings.Contains(v, "m.tb") ||
				strings.Contains(reqCount, "taobao.com") || strings.Contains(reqCount, "tmall.com") {
				// 淘口令
				//fmt.Println(s)
				pvd, goodsId, tklWord, _ = svc.FindTaobaoWord(eg, officialEg, args, v, user)
				tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, pvd, goodsId, v, tklWord, "0")
			}
			if strings.Contains(v, "haohuo.jinritemai.") {
				tikTokBase := svc.CommTik(eg, args["master_id"], v)
				url := strings.ReplaceAll(v, "?", "&") + "&"
				split := strings.Split(url, "&id=")
				if len(split) == 2 {
					split1 := strings.Split(split[1], "&")
					if len(split1) > 0 {
						tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_TIKTOK, split1[0], v, tklWord, "0")
						if zhios_third_party_utils.StrToInt(tikTokBase["tik_activity_id"]) > 0 && strings.Contains(tcPrase.GID, "cid") == false {
							tcPrase.GID += "cid" + tikTokBase["tik_activity_id"]
						}
					}
				}
			}
			if strings.Contains(v, "jd.") {
				//只有链接带有.html才会剥离出商品id
				if strings.Contains(v, ".html") {
					var index int
					s1 := v
					split := strings.Split(s1, "/")
					for i, s := range split {
						if strings.Contains(s, ".html") {
							index = i
						}
					}
					goodsidStrs := strings.Split(split[index], ".html")
					if len(goodsidStrs) > 0 {
						tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_JD, goodsidStrs[0], v, tklWord, "0")
					}
				} else {
					tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_JD, "", v, tklWord, "0")
				}
			}
			if strings.Contains(v, "pinduoduo.com") || strings.Contains(v, "yangkeduo.com") {
				split := strings.Split(v, "?")
				if len(split) > 1 {
					sUrl := strings.Split(split[1], "&")
					if len(sUrl) > 0 {
						for _, v2 := range sUrl {
							if strings.Contains(v2, "goods_id=") {
								goods := strings.Split(v2, "=")
								tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_PDD, goods[1], v, tklWord, "0")
							}
						}

					}
				} else {
					tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_PDD, "", v, tklWord, "0")
				}
			}
			if strings.Contains(v, "kaola.com") {
				var index int
				s1 := v
				split := strings.Split(s1, "/")
				for i, s := range split {
					if strings.Contains(s, ".html") {
						index = i
					}
				}
				goodsidStrs := strings.Split(split[index], ".html")
				if len(goodsidStrs) > 0 {
					tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_KL, goodsidStrs[0], v, tklWord, "0")
				}
				return tcPrase
			}
			if strings.Contains(v, "suning.") {
				r, _ := regexp.Compile(`/(\d+)/(\d+).html`)
				reg := r.FindStringSubmatch(v)
				if len(reg) < 3 {
					return tcPrase
				}
				bytes := []byte(reg[2])
				var index int
				for i, b := range bytes {
					if b != byte(48) {
						index = i
						break
					}
				}
				i := bytes[index:len(bytes)]
				fmt.Println(string(i))
				tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_SN, string(i), v, tklWord, "0")
			}
			if strings.Contains(v, "vip.") {

				gid := ""
				if strings.Contains(v, "goodsId=") {
					split := strings.Split(v+"&", "&")
					for _, v := range split {
						if strings.Contains(v, "goodsId=") {
							gid = strings.ReplaceAll(v, "goodsId=", "")
						}
					}
				} else {
					var index int
					s1 := v
					split := strings.Split(s1, "/")
					for i, s := range split {
						if strings.Contains(s, ".html") {
							index = i
						}
					}
					goodsidStrs := strings.Split(split[index], ".html")
					if len(goodsidStrs) > 0 {
						product := strings.Split(goodsidStrs[0], "-")
						gid = product[len(product)-1]
					}
				}

				tcPrase, reqCount = svc.CommGetGoods(eg, officialEg, args, tcPrase, isFirst, reqCount, md.PVD_VIP, gid, v, tklWord, "0")
			}
		}

	} else {
		pvd, goodsId, tklWord, _ := svc.FindTaobaoWord(eg, officialEg, args, reqCount, user)
		if goodsId != "" {
			tcPrase, _ = svc.CommGetGoods(eg, officialEg, args, tcPrase, 1, reqCount, pvd, goodsId, "", tklWord, "0")

		}
	}
	return tcPrase
}
