package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/db/model"
	"errors"
	"xorm.io/xorm"
)

// SysUnionByTaobaoByUseByAuth is 正在使用Taobao且已授权的设置
func SysUnionByTaobaoByUseByAuth(Db *xorm.Engine, masterId string) (*model.SysUnionSet, error) {
	var (
		m model.SysUnionSet
	)
	has, err := Db.Where("provider = 'taobao' AND is_use = 1 AND auth_status = 1").Get(&m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("找不到联盟设置")
	}

	return &m, nil
}
func SysUnionByMeituanByUseByAuth(Db *xorm.Engine, masterId string) (*model.SysUnionSet, error) {
	var (
		m model.SysUnionSet
	)
	has, err := Db.Where("provider = 'meituan' AND is_use = 1 ").Get(&m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("找不到联盟设置")
	}

	return &m, nil
}
func SysUnionByTikTokByUseByAuth(Db *xorm.Engine, masterId string) (*model.SysUnionSet, error) {
	var (
		m model.SysUnionSet
	)
	has, err := Db.Where("provider = 'tikTok' AND is_use = 1 ").Get(&m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("找不到联盟设置")
	}

	return &m, nil
}
func SysUnionByElmByUseByAuth(Db *xorm.Engine, masterId string) (*model.SysUnionSet, error) {
	var (
		m model.SysUnionSet
	)
	has, err := Db.Where("provider = 'elm' AND is_use = 1 ").Get(&m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("找不到联盟设置")
	}

	return &m, nil
}
func SysUnionByTikTokByUseByAuthId(Db *xorm.Engine, id string) (*model.SysUnionSet, error) {
	var (
		m model.SysUnionSet
	)
	has, err := Db.Where("provider = 'tikTok' AND id=? ", id).Get(&m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("找不到联盟设置")
	}

	return &m, nil
}
func SysUnionByTikTokByUseByAuthNoCache(Db *xorm.Engine, masterId string) (*model.SysUnionSet, error) {
	var (
		m model.SysUnionSet
	)

	has, err := Db.Where("provider = 'tikTok' AND is_use = 1 ").Get(&m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("找不到联盟设置")
	}
	return &m, nil
}

// SysUnionByPVDByUse is 正在使用的设置
func SysUnionByPVDByUse(Db *xorm.Engine, masterId, pvd string) (*model.SysUnionSet, error) {
	var (
		m model.SysUnionSet
	)
	has, err := Db.Where("provider = ? AND is_use = 1", pvd).Get(&m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("找不到联盟设置")
	}

	return &m, nil
}

// 更新记录
func SysUnionUpdate(Db *xorm.Engine, data *model.SysUnionSet) {
	row, err := Db.ID(data.Id).AllCols().Update(data)
	if err != nil || row == 0 {

	}
}
func SysUnionById(eg *xorm.Engine, id string) *model.SysUnionSet {
	var data model.SysUnionSet
	get, err := eg.Where("id=?", id).Get(&data)
	if get == false || err != nil {
		return nil
	}
	return &data
}
func SysUnionByKuaishouByUseByAuth(Db *xorm.Engine, masterId string) (*model.SysUnionSet, error) {
	var (
		m model.SysUnionSet
	)
	has, err := Db.Where("provider = 'kuaishou' AND is_use = 1 ").Get(&m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("找不到联盟设置")
	}

	return &m, nil
}
