package tik_tok

type TikTokGoods struct {
	Commission        string          `json:"commission"`
	CostPrice         string          `json:"cost_price"`
	DetailURL         string          `json:"detail_url"`
	GoodsID           string          `json:"goods_id"`
	GoodsImg          string          `json:"goods_img"`
	GoodsSales        string          `json:"goods_sales"`
	GoodsTitle        string          `json:"goods_title"`
	Imgs              []string        `json:"imgs"`
	InStock           string          `json:"in_stock"`
	Price             string          `json:"price"`
	Sharable          string          `json:"sharable"`
	ShopID            string          `json:"shop_id"`
	ShopName          string          `json:"shop_name"`
	ShopTotalScore    ShopTotalScore1 `json:"shop_total_score"`
	YhqPrice          string          `json:"yhq_price"`
	Cid               string          `json:"cid"`
	ActivityStartTime string          `json:"promotion_start_time"`
	ActivityEndTime   string          `json:"promotion_end_time"`
	PublicCommission  string          `json:"public_commission"`
	ServiceRatio      string          `json:"service_ratio"`
	UpdateTime        string          `json:"update_time"`
	ApplyId           string          `json:"apply_id"`
	ActivityId        string          `json:"activity_id"`
}
type TikTokGoodsLmNew struct {
	ActivityInfo struct {
		ActivityType interface{} `json:"activity_type"`
	} `json:"activity_info"`
	BaseInfo struct {
		CategoryId   int      `json:"category_id"`
		CategoryName string   `json:"category_name"`
		Cover        string   `json:"cover"`
		DetailUrl    string   `json:"detail_url"`
		FirstCid     int      `json:"first_cid"`
		Imgs         []string `json:"imgs"`
		InStock      bool     `json:"in_stock"`
		Price        int      `json:"price"`
		ProductId    int64    `json:"product_id"`
		Sales        int      `json:"sales"`
		SecondCid    int      `json:"second_cid"`
		Success      bool     `json:"success"`
		ThirdCid     int      `json:"third_cid"`
		Title        string   `json:"title"`
	} `json:"base_info"`
	BrandInfo struct {
		BrandId     interface{} `json:"brand_id"`
		BrandNameCn interface{} `json:"brand_name_cn"`
		BrandNameEn interface{} `json:"brand_name_en"`
	} `json:"brand_info"`
	CommentInfo struct {
		CommentNum   interface{} `json:"comment_num"`
		CommentScore interface{} `json:"comment_score"`
	} `json:"comment_info"`
	CouponInfo struct {
		AvailableCoupons []interface{} `json:"available_coupons"`
		CouponPrice      int           `json:"coupon_price"`
		Success          bool          `json:"success"`
	} `json:"coupon_info"`
	LogisticsInfo struct {
		Text interface{} `json:"text"`
	} `json:"logistics_info"`
	MonthSaleData struct {
		DailyStatistics []struct {
			Date     string `json:"date"`
			KolNum   int    `json:"kol_num"`
			OrderNum int    `json:"order_num"`
			ViewNum  int    `json:"view_num"`
		} `json:"daily_statistics"`
		KolNum   int  `json:"kol_num"`
		OrderNum int  `json:"order_num"`
		Success  bool `json:"success"`
		ViewNum  int  `json:"view_num"`
	} `json:"month_sale_data"`
	PresellInfo struct {
		PresellType interface{} `json:"presell_type"`
	} `json:"presell_info"`
	PromotionInfo struct {
		CommissionType int  `json:"commission_type"`
		CosFee         int  `json:"cos_fee"`
		CosRatio       int  `json:"cos_ratio"`
		KolCosFee      int  `json:"kol_cos_fee"`
		KolCosRatio    int  `json:"kol_cos_ratio"`
		Success        bool `json:"success"`
	} `json:"promotion_info"`
	QualificationInfo struct {
	} `json:"qualification_info"`
	RightsInfo struct {
	} `json:"rights_info"`
	ShareInfo struct {
		Sharable bool `json:"sharable"`
		Success  bool `json:"success"`
	} `json:"share_info"`
	ShopInfo struct {
		ShopId         int    `json:"shop_id"`
		ShopName       string `json:"shop_name"`
		ShopTotalScore struct {
			LogisticsScore struct {
				Level int    `json:"level"`
				Score string `json:"score"`
				Text  string `json:"text"`
			} `json:"logistics_score"`
			ProductScore struct {
				Level int    `json:"level"`
				Score string `json:"score"`
				Text  string `json:"text"`
			} `json:"product_score"`
			ServiceScore struct {
				Level int    `json:"level"`
				Score string `json:"score"`
				Text  string `json:"text"`
			} `json:"service_score"`
			ShopScore struct {
				Level int    `json:"level"`
				Score string `json:"score"`
				Text  string `json:"text"`
			} `json:"shop_score"`
		} `json:"shop_total_score"`
		Success bool `json:"success"`
	} `json:"shop_info"`
	Tags struct {
		HasDouinGoodsTag interface{} `json:"has_douin_goods_tag"`
	} `json:"tags"`
}
type TikTokGoodsLm struct {
	CosFee            int64       `json:"cos_fee"`
	CosRatio          float64     `json:"cos_ratio"`
	ActivityCosRatio  float64     `json:"activity_cos_ratio"`
	CouponPrice       int64       `json:"coupon_price"`
	Cover             string      `json:"cover"`
	DetailURL         string      `json:"detail_url"`
	FirstCid          int64       `json:"first_cid"`
	InStock           interface{} `json:"in_stock"`
	Price             int64       `json:"price"`
	ProductID         int64       `json:"product_id"`
	Sales             int64       `json:"sales"`
	SecondCid         int64       `json:"second_cid"`
	Sharable          interface{} `json:"sharable"`
	ShopID            int64       `json:"shop_id"`
	ShopName          string      `json:"shop_name"`
	ThirdCid          int64       `json:"third_cid"`
	Title             string      `json:"title"`
	ActivityStartTime string      `json:"promotion_start_time"`
	ActivityEndTime   string      `json:"promotion_end_time"`
	ServiceRatio      string      `json:"service_ratio"`
	Imgs              []string    `json:"imgs"`
	ShopTotalScore    interface{} `json:"shop_total_score"`
	UpdateTime        string      `json:"update_time"`
	ApplyId           int64       `json:"apply_id"`
}
type ShopTotalScoreData struct {
	Level int    `json:"level"`
	Score string `json:"score"`
	Text  string `json:"text"`
}
type ShopTotalScore struct {
	LogisticsScore ShopTotalScoreData `json:"logistics_score"`
	ProductScore   ShopTotalScoreData `json:"product_score"`
	ServiceScore   ShopTotalScoreData `json:"service_score"`
}
type ShopTotalScoreData1 struct {
	Level string `json:"level"`
	Score string `json:"score"`
	Text  string `json:"text"`
}
type ShopTotalScore1 struct {
	LogisticsScore ShopTotalScoreData1 `json:"logistics_score"`
	ProductScore   ShopTotalScoreData1 `json:"product_score"`
	ServiceScore   ShopTotalScoreData1 `json:"service_score"`
}
type TikTokLive struct {
	LiveId  string `json:"live_id"`
	Name    string `json:"name"`
	HeadImg string `json:"head_img"`
	FansNum string `json:"fans_num"`
	IsLive  string `json:"is_live"`
	Pvd     string `json:"pvd"`
}

type TikTokTeamOrder struct {
	ColonelOrderInfo struct {
		EstimatedCommission int64 `json:"estimated_commission"`
		RealCommission      int64 `json:"real_commission"`
	} `json:"colonel_order_info"`
	ColonelOrderInfoSecond struct {
		EstimatedCommission int64 `json:"estimated_commission"`
		RealCommission      int64 `json:"real_commission"`
	} `json:"colonel_order_info_second"`
	OrderID    string `json:"order_id"`
	SettleTime string `json:"settle_time"`
	Mid        string `json:"mid"`
}
type TikTokTeamOrderNew struct {
	Mid              string      `json:"mid"`
	AdsPromotionRate string      `json:"ads_promotion_rate"`
	App              string      `json:"app"`
	AuthorAccount    string      `json:"author_account"`
	AuthorBuyinId    interface{} `json:"author_buyin_id"`
	AuthorOpenid     string      `json:"author_openid"`
	AuthorShortId    string      `json:"author_short_id"`
	BuyerAppId       string      `json:"buyer_app_id"`
	ColonelOrderInfo struct {
		ActivityId            interface{} `json:"activity_id"`
		ColonelBuyinId        int64       `json:"colonel_buyin_id"`
		CommissionRate        interface{} `json:"commission_rate"`
		EstimatedCommission   interface{} `json:"estimated_commission"`
		InstitutionId         int64       `json:"institution_id"`
		InstitutionName       string      `json:"institution_name"`
		RealCommission        interface{} `json:"real_commission"`
		SettledTechServiceFee interface{} `json:"settled_tech_service_fee"`
		TechServiceFee        interface{} `json:"tech_service_fee"`
		TechServiceFeeRate    interface{} `json:"tech_service_fee_rate"`
	} `json:"colonel_order_info"`
	ColonelOrderInfoSecond struct {
		ActivityId          int    `json:"activity_id"`
		ColonelBuyinId      int64  `json:"colonel_buyin_id"`
		CommissionRate      int    `json:"commission_rate"`
		EstimatedCommission int    `json:"estimated_commission"`
		InstitutionId       int64  `json:"institution_id"`
		InstitutionName     string `json:"institution_name"`
		RealCommission      int    `json:"real_commission"`
	} `json:"colonel_order_info_second"`
	ColonelType        string      `json:"colonel_type"`
	CommissionRate     int         `json:"commission_rate"`
	DistributorBuyinId string      `json:"distributor_buyin_id"`
	DistributorName    string      `json:"distributor_name"`
	FlowPoint          string      `json:"flow_point"`
	GoodShareType      string      `json:"good_share_type"`
	IsTrusteeship      bool        `json:"is_trusteeship"`
	ItemNum            int         `json:"item_num"`
	MediaId            interface{} `json:"media_id"`
	MediaType          interface{} `json:"media_type"`
	OrderId            string      `json:"order_id"`
	PayGoodsAmount     int         `json:"pay_goods_amount"`
	PaySuccessTime     string      `json:"pay_success_time"`
	ProductId          string      `json:"product_id"`
	ProductImg         string      `json:"product_img"`
	ProductName        string      `json:"product_name"`
	RefundTime         interface{} `json:"refund_time"`
	SettleTime         interface{} `json:"settle_time"`
	SettledGoodsAmount int         `json:"settled_goods_amount"`
	ShopId             int         `json:"shop_id"`
	ShopName           string      `json:"shop_name"`
	TotalPayAmount     int         `json:"total_pay_amount"`
	UpdateTime         string      `json:"update_time"`
}
